#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TArc__
#define __HROOT_GRAF__TArc__

#include "HROOT-grafType.h"
#include "HROOTGrafTEllipse.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreDeletable.h"

#undef TARC_DECL_VIRT 
#define TARC_DECL_VIRT(Type) \


#undef TARC_DECL_NONVIRT 
#define TARC_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTArc ( double x1, double y1, double radius, double phimin, double phimax )

#undef TARC_DEF_VIRT
#define TARC_DEF_VIRT(Type)\


#undef TARC_DEF_NONVIRT
#define TARC_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTArc ( double x1, double y1, double radius, double phimin, double phimax )\
{\
Type * newp = new Type (x1, y1, radius, phimin, phimax); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TELLIPSE_DECL_VIRT(TArc);
TOBJECT_DECL_VIRT(TArc);
TATTLINE_DECL_VIRT(TArc);
TATTFILL_DECL_VIRT(TArc);
DELETABLE_DECL_VIRT(TArc);


TARC_DECL_VIRT(TArc);


TARC_DECL_NONVIRT(TArc);


#endif // __HROOT_GRAF__TArc__

#ifdef __cplusplus
}
#endif

