#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TArrow__
#define __HROOT_GRAF__TArrow__

#include "HROOT-grafType.h"
#include "HROOTGrafTLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-coreType.h"

#undef TARROW_DECL_VIRT 
#define TARROW_DECL_VIRT(Type) \


#undef TARROW_DECL_NONVIRT 
#define TARROW_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTArrow ( double x1, double y1, double x2, double y2, double arrowsize, const char* option )

#undef TARROW_DEF_VIRT
#define TARROW_DEF_VIRT(Type)\


#undef TARROW_DEF_NONVIRT
#define TARROW_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTArrow ( double x1, double y1, double x2, double y2, double arrowsize, const char* option )\
{\
Type * newp = new Type (x1, y1, x2, y2, arrowsize, option); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TLINE_DECL_VIRT(TArrow);
TATTFILL_DECL_VIRT(TArrow);
TOBJECT_DECL_VIRT(TArrow);
TATTLINE_DECL_VIRT(TArrow);
DELETABLE_DECL_VIRT(TArrow);


TARROW_DECL_VIRT(TArrow);


TARROW_DECL_NONVIRT(TArrow);


#endif // __HROOT_GRAF__TArrow__

#ifdef __cplusplus
}
#endif

