#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TCutG__
#define __HROOT_GRAF__TCutG__

#include "HROOT-grafType.h"
#include "HROOTHistTGraph.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-histType.h"

#undef TCUTG_DECL_VIRT 
#define TCUTG_DECL_VIRT(Type) \


#undef TCUTG_DECL_NONVIRT 
#define TCUTG_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTCutG ( const char* name, int n, double * x, double * y )

#undef TCUTG_DEF_VIRT
#define TCUTG_DEF_VIRT(Type)\


#undef TCUTG_DEF_NONVIRT
#define TCUTG_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTCutG ( const char* name, int n, double * x, double * y )\
{\
Type * newp = new Type (name, n, x, y); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TGRAPH_DECL_VIRT(TCutG);
TNAMED_DECL_VIRT(TCutG);
TATTLINE_DECL_VIRT(TCutG);
TATTFILL_DECL_VIRT(TCutG);
TATTMARKER_DECL_VIRT(TCutG);
TOBJECT_DECL_VIRT(TCutG);
DELETABLE_DECL_VIRT(TCutG);


TCUTG_DECL_VIRT(TCutG);


TCUTG_DECL_NONVIRT(TCutG);


#endif // __HROOT_GRAF__TCutG__

#ifdef __cplusplus
}
#endif

