#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TGraphQQ__
#define __HROOT_GRAF__TGraphQQ__

#include "HROOT-grafType.h"
#include "HROOTHistTGraph.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-histType.h"

#undef TGRAPHQQ_DECL_VIRT 
#define TGRAPHQQ_DECL_VIRT(Type) \


#undef TGRAPHQQ_DECL_NONVIRT 
#define TGRAPHQQ_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTGraphQQ ( int nx, double * x, int ny, double * y )

#undef TGRAPHQQ_DEF_VIRT
#define TGRAPHQQ_DEF_VIRT(Type)\


#undef TGRAPHQQ_DEF_NONVIRT
#define TGRAPHQQ_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTGraphQQ ( int nx, double * x, int ny, double * y )\
{\
Type * newp = new Type (nx, x, ny, y); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TGRAPH_DECL_VIRT(TGraphQQ);
TNAMED_DECL_VIRT(TGraphQQ);
TATTLINE_DECL_VIRT(TGraphQQ);
TATTFILL_DECL_VIRT(TGraphQQ);
TATTMARKER_DECL_VIRT(TGraphQQ);
TOBJECT_DECL_VIRT(TGraphQQ);
DELETABLE_DECL_VIRT(TGraphQQ);


TGRAPHQQ_DECL_VIRT(TGraphQQ);


TGRAPHQQ_DECL_NONVIRT(TGraphQQ);


#endif // __HROOT_GRAF__TGraphQQ__

#ifdef __cplusplus
}
#endif

