#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TSPHE__
#define __HROOT_GRAF__TSPHE__

#include "HROOT-grafType.h"
#include "HROOTGrafTShape.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TSPHE_DECL_VIRT 
#define TSPHE_DECL_VIRT(Type) \


#undef TSPHE_DECL_NONVIRT 
#define TSPHE_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTSPHE ( const char* name, const char* title, const char* material, double rmin, double rmax, double themin, double themax, double phimin, double phimax )

#undef TSPHE_DEF_VIRT
#define TSPHE_DEF_VIRT(Type)\


#undef TSPHE_DEF_NONVIRT
#define TSPHE_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTSPHE ( const char* name, const char* title, const char* material, double rmin, double rmax, double themin, double themax, double phimin, double phimax )\
{\
Type * newp = new Type (name, title, material, rmin, rmax, themin, themax, phimin, phimax); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TSHAPE_DECL_VIRT(TSPHE);
TNAMED_DECL_VIRT(TSPHE);
TATTLINE_DECL_VIRT(TSPHE);
TATTFILL_DECL_VIRT(TSPHE);
TATT3D_DECL_VIRT(TSPHE);
TOBJECT_DECL_VIRT(TSPHE);
DELETABLE_DECL_VIRT(TSPHE);


TSPHE_DECL_VIRT(TSPHE);


TSPHE_DECL_NONVIRT(TSPHE);


#endif // __HROOT_GRAF__TSPHE__

#ifdef __cplusplus
}
#endif

