#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TShape__
#define __HROOT_GRAF__TShape__

#include "HROOT-grafType.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-coreType.h"

#undef TSHAPE_DECL_VIRT 
#define TSHAPE_DECL_VIRT(Type) \


#undef TSHAPE_DECL_NONVIRT 
#define TSHAPE_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTShape ( const char* name, const char* title, const char* material )

#undef TSHAPE_DEF_VIRT
#define TSHAPE_DEF_VIRT(Type)\


#undef TSHAPE_DEF_NONVIRT
#define TSHAPE_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTShape ( const char* name, const char* title, const char* material )\
{\
Type * newp = new Type (name, title, material); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TNAMED_DECL_VIRT(TShape);
TATTLINE_DECL_VIRT(TShape);
TATTFILL_DECL_VIRT(TShape);
TATT3D_DECL_VIRT(TShape);
TOBJECT_DECL_VIRT(TShape);
DELETABLE_DECL_VIRT(TShape);


TSHAPE_DECL_VIRT(TShape);


TSHAPE_DECL_NONVIRT(TShape);


#endif // __HROOT_GRAF__TShape__

#ifdef __cplusplus
}
#endif

