{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Graf.TBRIK.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Graf.TBRIK.RawType
import HROOT.Graf.TBRIK.FFI
import HROOT.Graf.TBRIK.Interface
import HROOT.Graf.TBRIK.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Graf.TShape.RawType
import HROOT.Graf.TShape.Cast
import HROOT.Graf.TShape.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAtt3D.RawType
import HROOT.Core.TAtt3D.Cast
import HROOT.Core.TAtt3D.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITBRIK TBRIK

instance ITShape TBRIK

instance ITNamed TBRIK where
        setName = xform1 c_tbrik_setname
        setNameTitle = xform2 c_tbrik_setnametitle
        setTitle = xform1 c_tbrik_settitle

instance ITAttLine TBRIK where
        getLineColor = xform0 c_tbrik_getlinecolor
        getLineStyle = xform0 c_tbrik_getlinestyle
        getLineWidth = xform0 c_tbrik_getlinewidth
        resetAttLine = xform1 c_tbrik_resetattline
        setLineAttributes = xform0 c_tbrik_setlineattributes
        setLineColor = xform1 c_tbrik_setlinecolor
        setLineStyle = xform1 c_tbrik_setlinestyle
        setLineWidth = xform1 c_tbrik_setlinewidth

instance ITAttFill TBRIK where
        setFillColor = xform1 c_tbrik_setfillcolor
        setFillStyle = xform1 c_tbrik_setfillstyle

instance ITAtt3D TBRIK

instance ITObject TBRIK where
        draw = xform1 c_tbrik_draw
        findObject = xform1 c_tbrik_findobject
        getName = xform0 c_tbrik_getname
        isA = xform0 c_tbrik_isa
        paint = xform1 c_tbrik_paint
        printObj = xform1 c_tbrik_printobj
        saveAs = xform2 c_tbrik_saveas
        write = xform3 c_tbrik_write

instance IDeletable TBRIK where
        delete = xform0 c_tbrik_delete

newTBRIK ::
           (Castable c2 CString, Castable c1 CString, Castable c0 CString) =>
           c0 -> c1 -> c2 -> CDouble -> CDouble -> CDouble -> IO TBRIK
newTBRIK = xform5 c_tbrik_newtbrik
