{-# LANGUAGE FlexibleInstances, FlexibleContexts, TypeFamilies,
  MultiParamTypeClasses, OverlappingInstances, IncoherentInstances
  #-}
module HROOT.Graf.TGraphPolar.Cast where
import Foreign.Ptr
import FFICXX.Runtime.Cast
import System.IO.Unsafe
import HROOT.Graf.TGraphPolar.RawType
import HROOT.Graf.TGraphPolar.Interface

instance (ITGraphPolar a, FPtr a) => Castable a
         (Ptr RawTGraphPolar) where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))

instance Castable TGraphPolar (Ptr RawTGraphPolar) where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))
