{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Graf.TPad.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Graf.TPad.RawType
import HROOT.Graf.TPad.FFI
import HROOT.Graf.TPad.Interface
import HROOT.Graf.TPad.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITPad TPad

instance ITVirtualPad TPad where
        cd = xform1 c_tpad_cd
        divide_tvirtualpad = xform5 c_tpad_divide_tvirtualpad
        setLogx = xform1 c_tpad_setlogx
        setLogy = xform1 c_tpad_setlogy
        setLogz = xform1 c_tpad_setlogz

instance ITObject TPad where
        draw = xform1 c_tpad_draw
        findObject = xform1 c_tpad_findobject
        getName = xform0 c_tpad_getname
        isA = xform0 c_tpad_isa
        paint = xform1 c_tpad_paint
        printObj = xform1 c_tpad_printobj
        saveAs = xform2 c_tpad_saveas
        write = xform3 c_tpad_write

instance IDeletable TPad where
        delete = xform0 c_tpad_delete
