#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__
#define __HROOT_GRAF__

// Opaque type definition for TArc 
typedef struct TArc_tag TArc_t; 
typedef TArc_t * TArc_p; 
typedef TArc_t const* const_TArc_p; 


// Opaque type definition for TArrow 
typedef struct TArrow_tag TArrow_t; 
typedef TArrow_t * TArrow_p; 
typedef TArrow_t const* const_TArrow_p; 


// Opaque type definition for TAttImage 
typedef struct TAttImage_tag TAttImage_t; 
typedef TAttImage_t * TAttImage_p; 
typedef TAttImage_t const* const_TAttImage_p; 


// Opaque type definition for TBRIK 
typedef struct TBRIK_tag TBRIK_t; 
typedef TBRIK_t * TBRIK_p; 
typedef TBRIK_t const* const_TBRIK_p; 


// Opaque type definition for TCanvas 
typedef struct TCanvas_tag TCanvas_t; 
typedef TCanvas_t * TCanvas_p; 
typedef TCanvas_t const* const_TCanvas_p; 


// Opaque type definition for TCrown 
typedef struct TCrown_tag TCrown_t; 
typedef TCrown_t * TCrown_p; 
typedef TCrown_t const* const_TCrown_p; 


// Opaque type definition for TCutG 
typedef struct TCutG_tag TCutG_t; 
typedef TCutG_t * TCutG_p; 
typedef TCutG_t const* const_TCutG_p; 


// Opaque type definition for TEllipse 
typedef struct TEllipse_tag TEllipse_t; 
typedef TEllipse_t * TEllipse_p; 
typedef TEllipse_t const* const_TEllipse_p; 


// Opaque type definition for TGaxis 
typedef struct TGaxis_tag TGaxis_t; 
typedef TGaxis_t * TGaxis_p; 
typedef TGaxis_t const* const_TGaxis_p; 


// Opaque type definition for TGraphPolar 
typedef struct TGraphPolar_tag TGraphPolar_t; 
typedef TGraphPolar_t * TGraphPolar_p; 
typedef TGraphPolar_t const* const_TGraphPolar_p; 


// Opaque type definition for TGraphQQ 
typedef struct TGraphQQ_tag TGraphQQ_t; 
typedef TGraphQQ_t * TGraphQQ_p; 
typedef TGraphQQ_t const* const_TGraphQQ_p; 


// Opaque type definition for TLine 
typedef struct TLine_tag TLine_t; 
typedef TLine_t * TLine_p; 
typedef TLine_t const* const_TLine_p; 


// Opaque type definition for TPad 
typedef struct TPad_tag TPad_t; 
typedef TPad_t * TPad_p; 
typedef TPad_t const* const_TPad_p; 


// Opaque type definition for TPCON 
typedef struct TPCON_tag TPCON_t; 
typedef TPCON_t * TPCON_p; 
typedef TPCON_t const* const_TPCON_p; 


// Opaque type definition for TShape 
typedef struct TShape_tag TShape_t; 
typedef TShape_t * TShape_p; 
typedef TShape_t const* const_TShape_p; 


// Opaque type definition for TSPHE 
typedef struct TSPHE_tag TSPHE_t; 
typedef TSPHE_t * TSPHE_p; 
typedef TSPHE_t const* const_TSPHE_p; 


// Opaque type definition for TTUBE 
typedef struct TTUBE_tag TTUBE_t; 
typedef TTUBE_t * TTUBE_p; 
typedef TTUBE_t const* const_TTUBE_p; 


#endif // __HROOT_GRAF__

#ifdef __cplusplus
}
#endif

