#include <MacroPatternMatch.h>
#include "HROOTGrafTLine.h"
#include "HROOTCoreTAttFill.h"
#include "TArrow.h"
#include "HROOTGrafTArrow.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TLINE_DEF_VIRT(TArrow)
TATTFILL_DEF_VIRT(TArrow)
TOBJECT_DEF_VIRT(TArrow)
TATTLINE_DEF_VIRT(TArrow)
DELETABLE_DEF_VIRT(TArrow)

TARROW_DEF_VIRT(TArrow)

TARROW_DEF_NONVIRT(TArrow)

