#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TBRIK__
#define __HROOT_GRAF__TBRIK__

#include "HROOT-grafType.h"
#include "HROOTGrafTShape.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TBRIK_DECL_VIRT 
#define TBRIK_DECL_VIRT(Type) \


#undef TBRIK_DECL_NONVIRT 
#define TBRIK_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTBRIK ( const char* name, const char* title, const char* material, double dx, double dy, double dz )

#undef TBRIK_DEF_VIRT
#define TBRIK_DEF_VIRT(Type)\


#undef TBRIK_DEF_NONVIRT
#define TBRIK_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTBRIK ( const char* name, const char* title, const char* material, double dx, double dy, double dz )\
{\
Type * newp = new Type (name, title, material, dx, dy, dz); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TSHAPE_DECL_VIRT(TBRIK);
TNAMED_DECL_VIRT(TBRIK);
TATTLINE_DECL_VIRT(TBRIK);
TATTFILL_DECL_VIRT(TBRIK);
TATT3D_DECL_VIRT(TBRIK);
TOBJECT_DECL_VIRT(TBRIK);
DELETABLE_DECL_VIRT(TBRIK);


TBRIK_DECL_VIRT(TBRIK);


TBRIK_DECL_NONVIRT(TBRIK);


#endif // __HROOT_GRAF__TBRIK__

#ifdef __cplusplus
}
#endif

