#include <MacroPatternMatch.h>
#include "HROOTGrafTPad.h"
#include "TCanvas.h"
#include "HROOTGrafTCanvas.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TPAD_DEF_VIRT(TCanvas)
TVIRTUALPAD_DEF_VIRT(TCanvas)
TOBJECT_DEF_VIRT(TCanvas)
DELETABLE_DEF_VIRT(TCanvas)

TCANVAS_DEF_VIRT(TCanvas)

TCANVAS_DEF_NONVIRT(TCanvas)

