#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TCanvas__
#define __HROOT_GRAF__TCanvas__

#include "HROOT-grafType.h"
#include "HROOTGrafTPad.h"
#include "HROOTCoreTVirtualPad.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TCANVAS_DECL_VIRT 
#define TCANVAS_DECL_VIRT(Type) \


#undef TCANVAS_DECL_NONVIRT 
#define TCANVAS_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTCanvas ( const char* name, const char* title, int ww, int wh )

#undef TCANVAS_DEF_VIRT
#define TCANVAS_DEF_VIRT(Type)\


#undef TCANVAS_DEF_NONVIRT
#define TCANVAS_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTCanvas ( const char* name, const char* title, int ww, int wh )\
{\
Type * newp = new Type (name, title, ww, wh); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TPAD_DECL_VIRT(TCanvas);
TVIRTUALPAD_DECL_VIRT(TCanvas);
TOBJECT_DECL_VIRT(TCanvas);
DELETABLE_DECL_VIRT(TCanvas);


TCANVAS_DECL_VIRT(TCanvas);


TCANVAS_DECL_NONVIRT(TCanvas);


#endif // __HROOT_GRAF__TCanvas__

#ifdef __cplusplus
}
#endif

