#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TCrown__
#define __HROOT_GRAF__TCrown__

#include "HROOT-grafType.h"
#include "HROOTGrafTEllipse.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreDeletable.h"

#undef TCROWN_DECL_VIRT 
#define TCROWN_DECL_VIRT(Type) \


#undef TCROWN_DECL_NONVIRT 
#define TCROWN_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTCrown ( double x1, double y1, double radin, double radout, double phimin, double phimax )

#undef TCROWN_DEF_VIRT
#define TCROWN_DEF_VIRT(Type)\


#undef TCROWN_DEF_NONVIRT
#define TCROWN_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTCrown ( double x1, double y1, double radin, double radout, double phimin, double phimax )\
{\
Type * newp = new Type (x1, y1, radin, radout, phimin, phimax); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TELLIPSE_DECL_VIRT(TCrown);
TOBJECT_DECL_VIRT(TCrown);
TATTLINE_DECL_VIRT(TCrown);
TATTFILL_DECL_VIRT(TCrown);
DELETABLE_DECL_VIRT(TCrown);


TCROWN_DECL_VIRT(TCrown);


TCROWN_DECL_NONVIRT(TCrown);


#endif // __HROOT_GRAF__TCrown__

#ifdef __cplusplus
}
#endif

