#include <MacroPatternMatch.h>
#include "HROOTCoreTObject.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "TEllipse.h"
#include "HROOTGrafTEllipse.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TOBJECT_DEF_VIRT(TEllipse)
TATTLINE_DEF_VIRT(TEllipse)
TATTFILL_DEF_VIRT(TEllipse)
DELETABLE_DEF_VIRT(TEllipse)

TELLIPSE_DEF_VIRT(TEllipse)

TELLIPSE_DEF_NONVIRT(TEllipse)

