#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TEllipse__
#define __HROOT_GRAF__TEllipse__

#include "HROOT-grafType.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-coreType.h"

#undef TELLIPSE_DECL_VIRT 
#define TELLIPSE_DECL_VIRT(Type) \


#undef TELLIPSE_DECL_NONVIRT 
#define TELLIPSE_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTEllipse ( double x1, double y1, double r1, double r2, double phimin, double phimax, double theta )

#undef TELLIPSE_DEF_VIRT
#define TELLIPSE_DEF_VIRT(Type)\


#undef TELLIPSE_DEF_NONVIRT
#define TELLIPSE_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTEllipse ( double x1, double y1, double r1, double r2, double phimin, double phimax, double theta )\
{\
Type * newp = new Type (x1, y1, r1, r2, phimin, phimax, theta); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TOBJECT_DECL_VIRT(TEllipse);
TATTLINE_DECL_VIRT(TEllipse);
TATTFILL_DECL_VIRT(TEllipse);
DELETABLE_DECL_VIRT(TEllipse);


TELLIPSE_DECL_VIRT(TEllipse);


TELLIPSE_DECL_NONVIRT(TEllipse);


#endif // __HROOT_GRAF__TEllipse__

#ifdef __cplusplus
}
#endif

