#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TGaxis__
#define __HROOT_GRAF__TGaxis__

#include "HROOT-grafType.h"
#include "HROOTGrafTLine.h"
#include "HROOTCoreTAttText.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-coreType.h"

#undef TGAXIS_DECL_VIRT 
#define TGAXIS_DECL_VIRT(Type) \


#undef TGAXIS_DECL_NONVIRT 
#define TGAXIS_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTGaxis ( double xmin, double ymin, double xmax, double ymax, double wmin, double wmax, int ndiv, const char* chopt, double gridlength )

#undef TGAXIS_DEF_VIRT
#define TGAXIS_DEF_VIRT(Type)\


#undef TGAXIS_DEF_NONVIRT
#define TGAXIS_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTGaxis ( double xmin, double ymin, double xmax, double ymax, double wmin, double wmax, int ndiv, const char* chopt, double gridlength )\
{\
Type * newp = new Type (xmin, ymin, xmax, ymax, wmin, wmax, ndiv, chopt, gridlength); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TLINE_DECL_VIRT(TGaxis);
TATTTEXT_DECL_VIRT(TGaxis);
TOBJECT_DECL_VIRT(TGaxis);
TATTLINE_DECL_VIRT(TGaxis);
DELETABLE_DECL_VIRT(TGaxis);


TGAXIS_DECL_VIRT(TGaxis);


TGAXIS_DECL_NONVIRT(TGaxis);


#endif // __HROOT_GRAF__TGaxis__

#ifdef __cplusplus
}
#endif

