#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TGraphPolar__
#define __HROOT_GRAF__TGraphPolar__

#include "HROOT-grafType.h"
#include "HROOTHistTGraphErrors.h"
#include "HROOTHistTGraph.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"
#include "HROOT-histType.h"

#undef TGRAPHPOLAR_DECL_VIRT 
#define TGRAPHPOLAR_DECL_VIRT(Type) \


#undef TGRAPHPOLAR_DECL_NONVIRT 
#define TGRAPHPOLAR_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTGraphPolar ( int n, double * x, double * y, double * ex, double * ey )

#undef TGRAPHPOLAR_DEF_VIRT
#define TGRAPHPOLAR_DEF_VIRT(Type)\


#undef TGRAPHPOLAR_DEF_NONVIRT
#define TGRAPHPOLAR_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTGraphPolar ( int n, double * x, double * y, double * ex, double * ey )\
{\
Type * newp = new Type (n, x, y, ex, ey); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TGRAPHERRORS_DECL_VIRT(TGraphPolar);
TGRAPH_DECL_VIRT(TGraphPolar);
TNAMED_DECL_VIRT(TGraphPolar);
TATTLINE_DECL_VIRT(TGraphPolar);
TATTFILL_DECL_VIRT(TGraphPolar);
TATTMARKER_DECL_VIRT(TGraphPolar);
TOBJECT_DECL_VIRT(TGraphPolar);
DELETABLE_DECL_VIRT(TGraphPolar);


TGRAPHPOLAR_DECL_VIRT(TGraphPolar);


TGRAPHPOLAR_DECL_NONVIRT(TGraphPolar);


#endif // __HROOT_GRAF__TGraphPolar__

#ifdef __cplusplus
}
#endif

