#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TPCON__
#define __HROOT_GRAF__TPCON__

#include "HROOT-grafType.h"
#include "HROOTGrafTShape.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TPCON_DECL_VIRT 
#define TPCON_DECL_VIRT(Type) \


#undef TPCON_DECL_NONVIRT 
#define TPCON_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTPCON ( const char* name, const char* title, const char* material, double phi1, double dphi1, int nz )

#undef TPCON_DEF_VIRT
#define TPCON_DEF_VIRT(Type)\


#undef TPCON_DEF_NONVIRT
#define TPCON_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTPCON ( const char* name, const char* title, const char* material, double phi1, double dphi1, int nz )\
{\
Type * newp = new Type (name, title, material, phi1, dphi1, nz); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TSHAPE_DECL_VIRT(TPCON);
TNAMED_DECL_VIRT(TPCON);
TATTLINE_DECL_VIRT(TPCON);
TATTFILL_DECL_VIRT(TPCON);
TATT3D_DECL_VIRT(TPCON);
TOBJECT_DECL_VIRT(TPCON);
DELETABLE_DECL_VIRT(TPCON);


TPCON_DECL_VIRT(TPCON);


TPCON_DECL_NONVIRT(TPCON);


#endif // __HROOT_GRAF__TPCON__

#ifdef __cplusplus
}
#endif

