#include <MacroPatternMatch.h>
#include "HROOTCoreTVirtualPad.h"
#include "TPad.h"
#include "HROOTGrafTPad.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TVIRTUALPAD_DEF_VIRT(TPad)
TOBJECT_DEF_VIRT(TPad)
DELETABLE_DEF_VIRT(TPad)

TPAD_DEF_VIRT(TPad)

TPAD_DEF_NONVIRT(TPad)

