#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_GRAF__TTUBE__
#define __HROOT_GRAF__TTUBE__

#include "HROOT-grafType.h"
#include "HROOTGrafTShape.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAtt3D.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TTUBE_DECL_VIRT 
#define TTUBE_DECL_VIRT(Type) \


#undef TTUBE_DECL_NONVIRT 
#define TTUBE_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTTUBE ( const char* name, const char* title, const char* material, double rmin, double rmax, double dz, double aspect )

#undef TTUBE_DEF_VIRT
#define TTUBE_DEF_VIRT(Type)\


#undef TTUBE_DEF_NONVIRT
#define TTUBE_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTTUBE ( const char* name, const char* title, const char* material, double rmin, double rmax, double dz, double aspect )\
{\
Type * newp = new Type (name, title, material, rmin, rmax, dz, aspect); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TSHAPE_DECL_VIRT(TTUBE);
TNAMED_DECL_VIRT(TTUBE);
TATTLINE_DECL_VIRT(TTUBE);
TATTFILL_DECL_VIRT(TTUBE);
TATT3D_DECL_VIRT(TTUBE);
TOBJECT_DECL_VIRT(TTUBE);
DELETABLE_DECL_VIRT(TTUBE);


TTUBE_DECL_VIRT(TTUBE);


TTUBE_DECL_NONVIRT(TTUBE);


#endif // __HROOT_GRAF__TTUBE__

#ifdef __cplusplus
}
#endif

