{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Graf.TArc.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Graf.TArc.RawType
import HROOT.Graf.TEllipse.Interface

class ITEllipse a => ITArc a

upcastTArc :: forall a . (FPtr a, ITArc a) => a -> TArc
upcastTArc h
  = let fh = get_fptr h
        fh2 :: Ptr RawTArc = castPtr fh
      in cast_fptr_to_obj fh2

downcastTArc :: forall a . (FPtr a, ITArc a) => TArc -> a
downcastTArc h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
