{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Graf.TAttImage.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Graf.TAttImage.RawType
import HROOT.Core.Deletable.Interface

class IDeletable a => ITAttImage a

upcastTAttImage ::
                forall a . (FPtr a, ITAttImage a) => a -> TAttImage
upcastTAttImage h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttImage = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttImage ::
                  forall a . (FPtr a, ITAttImage a) => TAttImage -> a
downcastTAttImage h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
