{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Graf.TGaxis.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Graf.TGaxis.RawType
import HROOT.Graf.TLine.Interface
import HROOT.Core.TAttText.Interface

class (ITLine a, ITAttText a) => ITGaxis a

upcastTGaxis :: forall a . (FPtr a, ITGaxis a) => a -> TGaxis
upcastTGaxis h
  = let fh = get_fptr h
        fh2 :: Ptr RawTGaxis = castPtr fh
      in cast_fptr_to_obj fh2

downcastTGaxis :: forall a . (FPtr a, ITGaxis a) => TGaxis -> a
downcastTGaxis h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
