{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Graf.TPad.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Graf.TPad.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe "HROOTGrafTPad.h TPad_cd" c_tpad_cd ::
               Ptr RawTPad -> CInt -> IO (Ptr RawTPad)

foreign import ccall safe "HROOTGrafTPad.h TPad_divide_tvirtualpad"
               c_tpad_divide_tvirtualpad ::
               Ptr RawTPad -> CInt -> CInt -> CDouble -> CDouble -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_SetLogx"
               c_tpad_setlogx :: Ptr RawTPad -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_SetLogy"
               c_tpad_setlogy :: Ptr RawTPad -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_SetLogz"
               c_tpad_setlogz :: Ptr RawTPad -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_Draw" c_tpad_draw
               :: Ptr RawTPad -> CString -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_FindObject"
               c_tpad_findobject :: Ptr RawTPad -> CString -> IO (Ptr RawTObject)

foreign import ccall safe "HROOTGrafTPad.h TPad_GetName"
               c_tpad_getname :: Ptr RawTPad -> IO CString

foreign import ccall safe "HROOTGrafTPad.h TPad_IsA" c_tpad_isa ::
               Ptr RawTPad -> IO (Ptr RawTClass)

foreign import ccall safe "HROOTGrafTPad.h TPad_Paint" c_tpad_paint
               :: Ptr RawTPad -> CString -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_printObj"
               c_tpad_printobj :: Ptr RawTPad -> CString -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_SaveAs"
               c_tpad_saveas :: Ptr RawTPad -> CString -> CString -> IO ()

foreign import ccall safe "HROOTGrafTPad.h TPad_Write" c_tpad_write
               :: Ptr RawTPad -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe "HROOTGrafTPad.h TPad_delete"
               c_tpad_delete :: Ptr RawTPad -> IO ()
